# TerrainProvider

#### new Cesium.TerrainProvider()
Core/TerrainProvider.js 19

Provides terrain or other geometry for the surface of an ellipsoid. The surface geometry is organized into a pyramid of tiles according to a `TilingScheme`. This type describes an interface and is not intended to be instantiated directly.

##### See:

- EllipsoidTerrainProvider
- CesiumTerrainProvider
- VRTheWorldTerrainProvider
- GoogleEarthEnterpriseTerrainProvider

### Members

#### static Cesium.TerrainProvider.heightmapTerrainQuality : Number
Core/TerrainProvider.js 333

Specifies the quality of terrain created from heightmaps. A value of 1.0 will ensure that adjacent heightmap vertices are separated by no more than `Globe.maximumScreenSpaceError` screen pixels and will probably go very slowly. A value of 0.5 will cut the estimated level zero geometric error in half, allowing twice the screen pixels between adjacent heightmap vertices and thus rendering more quickly.

#### readonly availability : TileAvailability
Core/TerrainProvider.js 112

Gets an object that can be used to determine availability of terrain from this provider, such as at points and in rectangles. This function should not be called before `TerrainProvider#ready` returns true. This property may be undefined if availability information is not available.

#### readonly credit : Credit
Core/TerrainProvider.js 44

Gets the credit to display when this terrain provider is active. Typically this is used to credit the source of the terrain. This function should not be called before `TerrainProvider#ready` returns true.

#### readonly errorEvent : Event
Core/TerrainProvider.js 32

Gets an event that is raised when the terrain provider encounters an asynchronous error.. By subscribing to the event, you will be notified of the error and can potentially recover from it. Event listeners are passed an instance of `TileProviderError`.

#### readonly hasVertexNormals : Boolean
Core/TerrainProvider.js 99

Gets a value indicating whether or not the requested tiles include vertex normals. This function should not be called before `TerrainProvider#ready` returns true.

#### readonly hasWaterMask : Boolean
Core/TerrainProvider.js 88

Gets a value indicating whether or not the provider includes a water mask. The water mask indicates which areas of the globe are water rather than land, so they can be rendered as a reflective surface with animated waves. This function should not be called before `TerrainProvider#ready` returns true.

#### readonly ready : Boolean
Core/TerrainProvider.js 65

Gets a value indicating whether or not the provider is ready for use.

#### readonly readyPromise : Promise.<Boolean>
Core/TerrainProvider.js 75

Gets a promise that resolves to true when the provider is ready for use.

#### readonly tilingScheme : TilingScheme
Core/TerrainProvider.js 55

Gets the tiling scheme used by the provider. This function should not be called before `TerrainProvider#ready` returns true.

### Methods

#### static Cesium.TerrainProvider.getEstimatedLevelZeroGeometricErrorForAHeightmap(ellipsoid, tileImageWidth, numberOfTilesAtLevelZero) → Number
Core/TerrainProvider.js 343

Determines an appropriate geometric error estimate when the geometry comes from a heightmap.

Name | Type | Description
--- | --- | ---
`ellipsoid` | Ellipsoid | The ellipsoid to which the terrain is attached.
`tileImageWidth` | Number | The width, in pixels, of the heightmap associated with a single tile.
`numberOfTilesAtLevelZero` | Number | The number of tiles in the horizontal direction at tile level zero.

##### Returns:

An estimated geometric error.

#### static Cesium.TerrainProvider.getRegularGridIndices(width, height) → Uint16Array|Uint32Array
Core/TerrainProvider.js 129

Gets a list of indices for a triangle mesh representing a regular grid. Calling this function multiple times with the same grid width and height returns the same list of indices. The total number of vertices must be less than or equal to 65536.

Name | Type | Description
--- | --- | ---
`width` | Number | The number of vertices in the regular grid in the horizontal direction.
`height` | Number | The number of vertices in the regular grid in the vertical direction.

##### Returns:

The list of indices. Uint16Array gets returned for 64KB or less and Uint32Array for 4GB or less.

#### getLevelMaximumGeometricError(level) → Number
Core/TerrainProvider.js 372

Gets the maximum geometric error allowed in a tile at a given level. This function should not be called before `TerrainProvider#ready` returns true.

Name | Type | Description
--- | --- | ---
`level` | Number | The tile level for which to get the maximum geometric error.

##### Returns:

The maximum geometric error.

#### getTileDataAvailable(x, y, level) → Boolean|undefined
Core/TerrainProvider.js 383

Determines whether data for a tile is available to be loaded.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if not supported by the terrain provider, otherwise true or false.

#### loadTileDataAvailability(x, y, level) → undefined|Promise.<void>
Core/TerrainProvider.js 394

Makes sure we load availability data for a tile

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.

##### Returns:

Undefined if nothing need to be loaded or a Promise that resolves when all required tiles are loaded

#### requestTileGeometry(x, y, level, request) → Promise.<TerrainData>|undefined
Core/TerrainProvider.js 362

Requests the geometry for a given tile. This function should not be called before `TerrainProvider#ready` returns true. The result must include terrain data and may optionally include a water mask and an indication of which child tiles are available.

Name | Type | Description
--- | --- | ---
`x` | Number | The X coordinate of the tile for which to request geometry.
`y` | Number | The Y coordinate of the tile for which to request geometry.
`level` | Number | The level of the tile for which to request geometry.
`request` | Request | optional The request object. Intended for internal use only.

##### Returns:

A promise for the requested geometry. If this method returns undefined instead of a promise, it is an indication that too many requests are already pending and the request will be retried later.